{Este  um Software de Demonstrao de propriedade da Intelbras S.A.
no deve ser usado como produto fim.
Elaborado por: Fabiana Cristina da Silveira.
Objetivo: Mostrar os dados enviados pelo PABX.}

unit UnitICTI_1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Conecta: TSpeedButton;
    Senha: TButton;
    NovaConexao: TButton;
    Sair: TBitBtn;
    ClientSocket1: TClientSocket;
    Memo1: TMemo;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    procedure SairClick(Sender: TObject);
    procedure ConectaClick(Sender: TObject);
    procedure SenhaClick(Sender: TObject);
    procedure NovaConexaoClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Servidor: string;
  RecBuf: string;
implementation

{$R *.DFM}

{Sai do Programa}
procedure TForm1.SairClick(Sender: TObject);
begin
  ClientSocket1.Close;
  Close;
end;

{Conecta-se ao servidor  partir do cdigo IP da maquina conectada a ICTI 700.
atravs de ClientSocket1.Address := Servidor  e ClientSocket1.Active := True
OBS.: a propriedade Port do ClientSocket1 deve ser igual a 2000 (nmero
da porta TCP do Servidor ICTI 700.}
procedure TForm1.ConectaClick(Sender: TObject);
begin
  if ClientSocket1.Active then ClientSocket1.Active := False;
  if InputQuery('Computador onde est o servidor ', 'Endereo IP:', Servidor) then
    if Length(Servidor) > 0 then
    begin
      with ClientSocket1 do
      begin
        Address := Servidor;
        Active := True;
      end;
      conecta.enabled:=false; //desabilita boto Conecta
      Senha.enabled:=true; //Habilita o boto Envia Senha
      NovaConexao.enabled:=true; //Habilita o boto Nova Conexo.
    end;
end;

{Envia a senha do PABX, se a senha estiver correta, o PABX inicia o envio dos dados.
OBS.: A senha enviada  123, nas posies 6,7 e 8 da variavel Buf}
procedure TForm1.SenhaClick(Sender: TObject);
var
    buf : array [1..30] of byte;
begin
    buf [1]:= $55;
    buf [2]:= 5;
    buf [3]:= 0;
    buf [4]:= $71;
    buf [5]:= 3;
    buf [6]:= $31;
    buf [7]:= $32;
    buf [8]:= $33;
    ClientSocket1.Socket.SendBuf (Buf, 8);
    Senha.enabled:=false;
end;

{Habilita o boto conecta, limpa variavel Servidor e Memo1 e
desabilita ClientSocket1.Active}
procedure TForm1.NovaConexaoClick(Sender: TObject);
begin
  conecta.enabled:=true;
  Servidor:='';
  Memo1.clear;
  ClientSocket1.Active := False;
end;

{Converte um nmero p/ Hexadecimal}
function Hexa (n : byte) : string;
const
    chexa : array [0..15] of char = '0123456789ABCDEF';
begin
    Hexa:= chexa [n div 16] + chexa [n mod 16]
end;

{Recebe os dados enviados pelo PABX, a variavel TamBuf recebe o tamanho total do Buf
Converte p/ Hexadecimal cada posio da variavel Buf e armazena
na variavel Recebe aps ser varrida toda a variavel TamBuf os dados que esto
na variavel Recebe so mostrados na tela atravs do Memo1.}
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
    TamBuf, i : integer;
    buf : array [1..1000] of byte;
begin
    TamBuf:= Socket.ReceiveBuf(Buf, 1000);
    RecBuf:='';
    for i:= 1 to TamBuf do
      RecBuf:= RecBuf + ' ' + hexa (buf [i]);
    Memo1.Lines.Add(RecBuf);
end;

{Desabilita os botes de Enviar Senha e Nova Conexo ao iniciar o programa}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Senha.enabled:=false;
  NovaConexao.enabled:=false;
end;

end.
