unit shSerializacao;

interface

uses
  System.Xml.Serialization,
  System.Collections;        // <--adicionar

type
  [System.Xml.Serialization.XmlRootAttribute]
  TShFuncionario = class
  private
    fnome,
      fcargo,
      fdepartamento : string;
    fFilhos : ArrayList;

  protected
  public
    function getFilhos: ArrayList;
    procedure setFilhos(const Value: ArrayList);
    function getCargo: string;
    function getDepartamento: string;
    function getNome: string;
    procedure setCargo(const Value: string);
    procedure setDepartamento(const Value: string);
    procedure setNome(const Value: string);
  public
    [XmlAttributeAttribute()]
    property nome : string read getNome write setNome;

    [XmlElementAttribute()]
    property cargo : string read getCargo write setCargo;

    [XmlElementAttribute()]
    property departamento : string read getDepartamento write setDepartamento;

    [XmlArrayItem('filho')]
    property filhos : ArrayList read getFilhos write setFilhos;

    constructor Create;
end;

implementation

{$AUTOBOX ON}



{ TShFuncionario }
function TShFuncionario.getDepartamento: string;
begin
  result := fdepartamento;
end;

procedure TShFuncionario.setDepartamento(const Value: string);
begin
  fdepartamento :=  Value;
end;

function TShFuncionario.getCargo: string;
begin
  result := fcargo;
end;

procedure TShFuncionario.setCargo(const Value: string);
begin
  fcargo :=  Value;
end;

function TShFuncionario.getNome: string;
begin
  result := fnome;
end;

procedure TShFuncionario.setNome(const Value: string);
begin
  fnome :=  Value;
end;

function TShFuncionario.getFilhos: ArrayList;
begin
  Result := fFilhos;
end;

procedure TShFuncionario.setFilhos(const Value: ArrayList);
begin
  Filhos := Value;
end;

constructor TShFuncionario.Create;
begin
  inherited;
  fFilhos := ArrayList.Create;
end;

end.
