unit untFrmSerializacao;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data,
  System.IO,                 // <--- adicionar
  System.Xml.Serialization;  // <--- adicionar

type
  TWinForm1 = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    btnSerializar: System.Windows.Forms.Button;
    btnDesserializar: System.Windows.Forms.Button;
    RichTextBox1: System.Windows.Forms.RichTextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure btnDesserializar_Click(sender: System.Object; e: System.EventArgs);
    procedure btnSerializar_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
    const arquivoxml = 'funcionario.xml';
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm1))]

implementation

uses shSerializacao;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm1.InitializeComponent;
begin
  Self.btnSerializar := System.Windows.Forms.Button.Create;
  Self.btnDesserializar := System.Windows.Forms.Button.Create;
  Self.RichTextBox1 := System.Windows.Forms.RichTextBox.Create;
  Self.SuspendLayout;
  // 
  // btnSerializar
  // 
  Self.btnSerializar.Location := System.Drawing.Point.Create(8, 8);
  Self.btnSerializar.Name := 'btnSerializar';
  Self.btnSerializar.TabIndex := 0;
  Self.btnSerializar.Text := 'Serilizar';
  Include(Self.btnSerializar.Click, Self.btnSerializar_Click);
  // 
  // btnDesserializar
  // 
  Self.btnDesserializar.Location := System.Drawing.Point.Create(88, 8);
  Self.btnDesserializar.Name := 'btnDesserializar';
  Self.btnDesserializar.Size := System.Drawing.Size.Create(88, 23);
  Self.btnDesserializar.TabIndex := 1;
  Self.btnDesserializar.Text := 'Desserializar';
  Include(Self.btnDesserializar.Click, Self.btnDesserializar_Click);
  // 
  // RichTextBox1
  // 
  Self.RichTextBox1.Location := System.Drawing.Point.Create(8, 40);
  Self.RichTextBox1.Name := 'RichTextBox1';
  Self.RichTextBox1.Size := System.Drawing.Size.Create(264, 192);
  Self.RichTextBox1.TabIndex := 2;
  Self.RichTextBox1.Text := 'RichTextBox1';
  //
  // TWinForm1
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(292, 266);
  Self.Controls.Add(Self.RichTextBox1);
  Self.Controls.Add(Self.btnDesserializar);
  Self.Controls.Add(Self.btnSerializar);
  Self.Name := 'TWinForm1';
  Self.Text := 'Serializao de Objetos';
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm1.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm1.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

procedure TWinForm1.btnSerializar_Click(sender: System.Object; e: System.EventArgs);
var
  funcionario : TShFuncionario;
  tr : TextWriter;
  serializador : XMLSerializer;
begin
  //criando e setando as informaes sobre o funcionrio
  funcionario := TshFuncionario.Create();
  with funcionario do
  begin
    nome := 'Sergio Henrique';
    cargo := 'Analista de Sistemas';
    departamento := 'Divisao de Manutencao de sistemas';
    //adicionando os filhos
    filhos.Add('Sarafe');
    filhos.Add('Sama');
  end;

  //criando objeto usado para escrever arquivos texto
  tr := StreamWriter.Create( arquivoxml );

  try
     //criando o serializador que ir transformar a classe em um xml
     serializador := XmlSerializer.Create( funcionario.GetType );

     //efetuando a serializao, observe no diretrio do exemplo o xml gerado
     serializador.Serialize(tr, funcionario);
 finally
   //fechando o escritor de arquivos texto
   tr.Close();
 end;

end;

procedure TWinForm1.btnDesserializar_Click(sender: System.Object; e: System.EventArgs);
var
  funcionario : TShFuncionario;
  fs : FileStream;
  serializador : XMLSerializer;
  i: Byte;
const
  quebra = #13#10;

begin

  //criando o objeto de funcionrio
  funcionario := TShFuncionario.Create();

  //criando fluxo de arquivo para ler o arquivo xml
  fs := FileStream.Create( arquivoxml, FileMode.Open );

  //criando o objeto serializador
  serializador := XmlSerializer.Create( funcionario.GetType );

  //efetuando a desserializao
  funcionario :=  serializador.Deserialize(fs) as TShFuncionario;
  fs.Close();

  //exibindo dados da classe no richtextbox1
  with RichTextBox1 do
  begin
    Clear();
    AppendText('Funcionario: ' + funcionario.nome + quebra);
    AppendText('cargo: ' + funcionario.cargo + #13#10);
    AppendText('departamento: ' + funcionario.departamento + #13#10);

    AppendText(#13#10 + 'Filhos: ' + #13#10);
    for i := 0 to funcionario.filhos.Count-1 do
    begin
       AppendText( funcionario.filhos[i].ToString + #13#10);
    end;
  end;
end;


end.
